<template>
  <div class="repository">
    <div class="repo-heading">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12 col-xl-8 offset-xl-2">
            <div class="title">{{ selectedRepository.displayName }}</div>
            <div class="subtitle">
              https://git.scepter.dev/{{ project.name }}/{{
                selectedRepository.name
              }}.git
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="repo-body">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12 col-xl-8 offset-xl-2">
            <div class="page-title">Files</div>
            <keep-alive>
              <repository-files
                v-if="selectedBranch"
                :branch="selectedBranch"
                :project="this.project.name"
                :repository="this.selectedRepository"
              ></repository-files>
            </keep-alive>
          </div>
          <div class="col-12 col-xl-8 offset-xl-2">
            <div class="page-title">Credentials</div>
            <div class="credential" v-for="credential in selectedRepository.credentials" :key="credential.id">
              <div class="username"><i class="fas fa-user"></i>{{credential.username}}</div>
              <div class="password"><i class="fas fa-lock"></i>
                <i class="fas fa-asterisk"></i>
                <i class="fas fa-asterisk"></i>
                <i class="fas fa-asterisk"></i>
                <i class="fas fa-asterisk"></i>
                <i class="fas fa-asterisk"></i>
                <i class="fas fa-asterisk"></i>
              </div>
              <div class="delete">
                <button class="button float-right" @click="deleteCredentialModal(credential)">Delete Credential</button>
              </div>
            </div>
            <div v-if="selectedRepository.credentials.length === 0">
              No credentials created yet.
            </div>
            <button class="button float-right" @click="createCredentialModal">Create Credential</button>
          </div>
        </div>
      </div>
    </div>
    <div class="repo-footer">
      <div class="container-fluid">
        <div class="col-12 col-xl-8 offset-xl-2">
          <button
            class="button float-right"
            @click="deleteRepositoryConfirmation">
            Delete repository
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import RepositoryFiles from "../../RepositoryFiles";
import CreateCredential from "../../../../components/modals/CreateCredential";
export default {
  components: {
    RepositoryFiles
  },
  computed: {
    ...mapState("projectModule", ["selectedRepository", "project"])
  },
  methods: {
    ...mapActions("projectModule", ["deleteRepository", "deleteCredential"]),
    createCredentialModal() {
      this.$modal.show(CreateCredential, {
        repository: this.selectedRepository
      });
    },
    deleteCredentialModal(credential) {
      this.$modal.show("dialog", {
        title: "Delete credentials",
        text: "Are you sure you want to delete these credentials?",
        buttons: [
          {
            title: "Delete",
            default: true,
            handler: () => this.deleteCredential({repository: this.selectedRepository.id, credential}).then(() => {
              this.$modal.hide('dialog')
            })
          },
          {
            title: "Cancel"
          }
        ]
      });
    },
    deleteRepositoryConfirmation() {
      this.$modal.show("dialog", {
        title: "Delete Repository",
        text: "Are you sure you want to delete this repository?",
        buttons: [
          {
            title: "Delete",
            default: true,
            handler: () => this.deleteRepository().then(() => {
              this.$toasters['main'].success("Repository deleted")
            })
          },
          {
            title: "Cancel"
          }
        ]
      });
    }
  },
  data() {
    return {
      selectedBranch: null
    };
  },
  mounted() {
    this.selectedBranch = this.selectedRepository.defaultBranch;
  }
};
</script>

<style lang="scss" scoped>
.repository {
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: column;

  .repo-heading {
    padding-top: 10px;
    padding-bottom: 10px;
    .title {
      font-size: 22px;
      font-weight: bold;
      color: #414141;
    }

    .subtitle {
      font-size: 18px;
      font-weight: 600;
      color: #6a6a6a;
    }
  }

  .repo-body {
    flex: 1;
    overflow-y: auto;
    border-top: 1px solid #d5d5d5;
    border-bottom: 1px solid #d5d5d5;
  }

  .repo-footer {
    padding-top: 10px;
    padding-bottom: 10px;
  }
  .credential{
    margin-bottom:10px;
    border:1px solid #e5e5e5;
    border-radius:8px;
    padding:10px;
    display:flex;
    color:#454545;
    align-items: center;
    .username{
      font-weight:bold;
      i{
        margin-right:10px;
        color:#454545;
      }
    }
    .password{
      margin-left:40px;
      font-weight: bold;
      color: #595959;
      i{
        margin-right:10px;
        color:#454545;
        &.fa-asterisk{
          font-size:12px;
          margin-right:3px;
        }
      }
    }
    .delete{
      flex:1;
    }
  }
}
</style>
